/*
*  RAL -- Rubrica Addressbook Library
*  file: date.h
*  
*  Copyright (C) Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _RUBRICA_DATE_H
#define _RUBRICA_DATE_H

#include <time.h>
#include <glib.h>
#include <glib-object.h>


#define RUBRICA_DATE_TYPE             (rubrica_date_get_type())

#define RUBRICA_DATE(obj)             (G_TYPE_CHECK_INSTANCE_CAST((obj), \
                                       RUBRICA_DATE_TYPE,               \
                                       RubricaDate))

#define RUBRICA_DATE_CLASS(klass)     (G_TYPE_CHECK_CLASS_CAST((klass),  \
                                       RUBRICA_DATE_TYPE,               \
                                       RubricaDateClass))

#define IS_RUBRICA_DATE(obj)          (G_TYPE_CHECK_INSTANCE_TYPE((obj), \
                                       RUBRICA_DATE_TYPE))

#define IS_RUBRICA_DATE_CLASS(klass)  (G_TYPE_CHECK_CLASS_TYPE((klass),  \
                                       RUBRICA_DATE_TYPE))

#define RUBRICA_DATE_GET_CLASS(klass) (G_TYPE_INSTANCE_GET_CLASS((kls),  \
                                       RUBRICA_DATE_TYPE,               \
                                       RubricaDateClass))



typedef struct _RubricaDate        RubricaDate;  
typedef struct _RubricaDateClass   RubricaDateClass;
typedef struct _RubricaDatePrivate RubricaDatePrivate;


struct _RubricaDate
{
  GObject parent; 
  
  RubricaDatePrivate *private;
};


struct _RubricaDateClass
{
  GObjectClass parent_class;
};



GType        rubrica_date_get_type      (void);

 

RubricaDate* rubrica_date_new           (void);
void         rubrica_date_free          (RubricaDate* date);


void         rubrica_date_know_date     (RubricaDate* date, gboolean know);
void         rubrica_date_set_date      (RubricaDate* date, time_t the_date);

gboolean     rubrica_date_is_date_known (RubricaDate* date);

time_t       rubrica_date_get_date      (RubricaDate* date);
gchar*       rubrica_date_get_day       (RubricaDate* date);
gchar*       rubrica_date_get_month     (RubricaDate* date);
gchar*       rubrica_date_get_year      (RubricaDate* date);

RubricaDate* rubrica_date_copy          (RubricaDate* date);

#endif
