/*
*  RAL -- Rubrica Addressbook Library
*  file: groups.h
*  
*  Copyright (C) Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _RUBRICA_GROUPS_H
#define _RUBRICA_GROUPS_H

#include <glib.h>
#include <glib-object.h>

#include "utils.h"
#include "groups.h"


#define RUBRICA_GROUPS_TYPE           (rubrica_groups_get_type())

#define RUBRICA_GROUPS(obj)           (G_TYPE_CHECK_INSTANCE_CAST((obj),    \
                                       RUBRICA_GROUPS_TYPE, RubricaGroups))

#define RUBRICA_GROUPS_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST((klass),     \
                                       RUBRICA_GROUPS_TYPE,                 \
                                       RubricaGroupsClass))

#define IS_RUBRICA_GROUPS(obj)        (G_TYPE_CHECK_INSTANCE_TYPE((obj),    \
                                       RUBRICA_GROUPS_TYPE))

#define IS_RUBRICA_GROUPS_CLASS(kls)  (G_TYPE_CHECK_CLASS_TYPE((kls),       \
                                       RUBRICA_GROUPS_TYPE))

#define RUBRICA_GROUPS_GET_CLASS(kls) (G_TYPE_INSTANCE_GET_CLASS((kls),     \
				       RUBRICA_GROUPS_TYPE,                 \
                                       RubricaGroupsClass))



typedef struct _RubricaGroups        RubricaGroups;
typedef struct _RubricaGroupsClass   RubricaGroupsClass;
typedef struct _RubricaGroupsPrivate RubricaGroupsPrivate;


struct _RubricaGroups {
  GObject parent;
  
  RubricaGroupsPrivate* private;  
};


struct _RubricaGroupsClass {
  GObjectClass parent;
};



GType          rubrica_groups_get_type (void);


RubricaGroups* rubrica_groups_new      (void);
void           rubrica_groups_free     (RubricaGroups* self);
RubricaGroups* rubrica_groups_copy     (RubricaGroups* self);

gboolean rubrica_groups_add_group      (RubricaGroups* self, gchar* group);
gboolean rubrica_groups_delete_group   (RubricaGroups* self, gchar* group);
gboolean rubrica_groups_modify_group   (RubricaGroups* self, gchar* old, 
					gchar* new);

gboolean rubrica_groups_owns_group     (RubricaGroups* self, gchar* group);

gchar*   rubrica_groups_get_group      (RubricaGroups* self);
gchar*   rubrica_groups_get_next_group (RubricaGroups* self);
gchar*   rubrica_groups_get_prev_group (RubricaGroups* self);
void     rubrica_groups_reset          (RubricaGroups* self);

// gpointer rubrica_group_get_group_by_id (RubricaGroup* self, gchar* id);

/* 
   aggiungere:
              ricerca per categoria
	      ... ?
 */
#endif
