/*
*  RAL -- Rubrica Addressbook Library
*  file: load.h
*  
*  Copyright (C) Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef _RUBRICA_LOAD_H
#define _RUBRICA_LOAD_H


#include <glib.h>
#include <libxml/tree.h>

#include "card.h"
#include "personal.h"
#include "company.h"
#include "error.h"

xmlDocPtr  rubrica_load_open_doc          (gchar* filename, RubricaError* err);

gint       rubrica_load_get_fileformat    (xmlDocPtr xdoc, RubricaError* err);
gchar*     rubrica_load_get_version       (xmlDocPtr xdoc, RubricaError* err);
gchar*     rubrica_load_get_document_tpye (xmlDocPtr xdoc, RubricaError* err);
gboolean   rubrica_load_is_rubrica_doc    (xmlDocPtr xdoc, RubricaError* err);



RubricaPersonalCard* rubrica_load_read_personal_xmlcard (xmlNodePtr xmlcard);
RubricaCompanyCard*  rubrica_load_read_company_xmlcard  (xmlNodePtr xmlcard); 

RubricaPersonalCard* rubrica_load_read_old_personal_xmlcard (xmlNodePtr xmlcard);

#endif
