/*
*  RAL -- Rubrica Addressbook Library 
*  file: ref.h 
*  
*  Copyright (C) Nicola Fragale <nicolafragale@libero.it> 
*
*  This program is free software; you can redistribute it and/or modify 
*  it under the terms of the GNU General Public License as published by 
*  the Free Software Foundation; either version 2 of the License, or 
*  (at your option) any later version. 
*
*  This program is distributed in the hope that it will be useful, 
*  but WITHOUT ANY WARRANTY; without even the implied warranty of 
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the 
*  GNU General Public License for more details. 
*
*  You should have received a copy of the GNU General Public License 
*  along with this program; if not, write to the Free Software 
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA. 
*/ 

#ifndef _RUBRICA_REF_H
#define _RUBRICA_REF_H

#include <glib.h>
#include <glib-object.h>


#define RUBRICA_REF_TYPE           (rubrica_ref_get_type())

#define RUBRICA_REF(obj)           (G_TYPE_CHECK_INSTANCE_CAST((obj),      \
		                    RUBRICA_REF_TYPE, RubricaRef))

#define RUBRICA_REF_CLASS(klass)   (G_TYPE_CHECK_CLASS_CAST((klass),       \
                                    RUBRICA_REF_TYPE, RubricaRefClass))

#define IS_RUBRICA_REF(obj)        (G_TYPE_CHECK_INSTANCE_TYPE((obj),      \
                                    RUBRICA_REF_TYPE))

#define IS_RUBRICA_REF_CLASS(kls)  (G_TYPE_CHECK_CLASS_TYPE((kls),         \
                                    RUBRICA_REF_TYPE))

#define RUBRICA_REF_GET_CLASS(kls) (G_TYPE_INSTANCE_GET_CLASS((kls),       \
                                    RUBRICA_REF_TYPE, RubricaRefClass))


typedef struct _RubricaRef        RubricaRef;
typedef struct _RubricaRefClass   RubricaRefClass;
typedef struct _RubricaRefPrivate RubricaRefPrivate;



struct _RubricaRef
{
  GObject parent;

  RubricaRefPrivate* private;
};


struct _RubricaRefClass
{
  GObjectClass parent;
};



GType       rubrica_ref_get_type    (void);


RubricaRef* rubrica_ref_new         (void);
RubricaRef* rubrica_ref_with_id_new (gchar* id);
void        rubrica_ref_free        (RubricaRef* self);

RubricaRef* rubrica_ref_copy        (RubricaRef* self);

void        rubrica_ref_set_id      (RubricaRef* self, gchar* id);
void        rubrica_ref_set_info    (RubricaRef* self, gchar* info);

gchar*      rubrica_ref_get_id      (RubricaRef* self);
gchar*      rubrica_ref_get_info    (RubricaRef* self);


//void rubrica_ref_set(RubricaRef* self, const gchar* property, gchar* val);


#endif
