/*
*  RAL -- Rubrica Addressbook Library
*  file: timeout.h
*
*  
*  Copyright (C) 2000-2001 Nicola Fragale <nicolafragale@libero.it>
*
*  This program is free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  This program is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  You should have received a copy of the GNU General Public License
*  along with this program; if not, write to the Free Software
*  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
*/

#ifndef __RUBRICA_TIMEOUT_H
#define __RUBRICA_TIMEOUT_H


#include <glib.h>
#include <glib-object.h>


#define RUBRICA_TIMEOUT_TYPE            (rubrica_timeout_get_type())

#define RUBRICA_TIMEOUT(obj)            (G_TYPE_CHECK_INSTANCE_CAST((obj), \
                                         RUBRICA_TIMEOUT_TYPE,             \
                                         RubricaTimeout))

#define RUBRICA_TIMEOUT_CLASS(klass)    (G_TYPE_CHECK_CLASS_CAST((klass),  \
                                         RUBRICA_TIMEOUT_TYPE,             \
                                         RubricaTimeoutClass))

#define IS_RUBRICA_TIMEOUT(obj)         (G_TYPE_CHECK_INSTANCE_TYPE((obj), \
                                         RUBRICA_TIMEOUT_TYPE))

#define IS_RUBRICA_TIMEOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE((klass),  \
                                         RUBRICA_TIMEOUT_TYPE))

#define RUBRICA_TIMEOUT_GET_CLASS(obj)  (G_TYPE_INSTANCE_GET_CLASS((obj),  \
                                         RUBRICA_TIMEOUT_TYPE,             \
                                         RubricaTimeoutClass))


typedef struct _RubricaTimeout          RubricaTimeout;
typedef struct _RubricaTimeoutClass     RubricaTimeoutClass;
typedef struct _RubricaTimeoutPrivate   RubricaTimeoutPrivate;


struct _RubricaTimeout 
{
  GObject parent;

  guint32 wait_time; 

  RubricaTimeoutPrivate* private;
};

struct _RubricaTimeoutClass
{
  GObjectClass parent;

  /* signals */
  void (*timeout_signal) (RubricaTimeout* timeout);
};


GType           rubrica_timeout_get_type   (void);

RubricaTimeout* rubrica_timeout_new        (guint32 time);
void            rubrica_timeout_free       (RubricaTimeout* timeout);

void            rubrica_timeout_start      (RubricaTimeout* timeout);
void            rubrica_timeout_enable     (RubricaTimeout* timeout);
void            rubrica_timeout_disable    (RubricaTimeout* timeout);
void            rubrica_timeout_restart    (RubricaTimeout* timeout,
					    guint32 time);

gboolean        rubrica_timeout_is_running (RubricaTimeout* timeout);

#endif
