#include <glib.h>

#include <libral.h>

int 
main (int argc, char* argv[])
{
  RubricaAddress* address;
  gchar *tipo, *via, *numero, *citta, *cap, *provincia, *stato, *nazione;
  
  g_type_init();

  via = numero = citta = cap = provincia = stato = nazione = NULL;

  address = rubrica_address_new();

  rubrica_address_set(address, RUBRICA_ADDRESS_HOME, "c/da Foresta", 
		      "65", "Lamezia Terme", "88046", "CZ", "UE",
		      "Italia");
  
  g_print("\n\nTipo: %s",    rubrica_address_get_address_type(address));
  g_print("\nvia: %s",       rubrica_address_get_street(address));
  g_print("\nnumero: %s",    rubrica_address_get_number(address));
  g_print("\ncitta': %s",    rubrica_address_get_city(address));
  g_print("\ncap: %s",       rubrica_address_get_zip(address));
  g_print("\nprovincia: %s", rubrica_address_get_province(address));
  g_print("\nstato: %s",     rubrica_address_get_state(address));
  g_print("\nnazione: %s",   rubrica_address_get_country(address));

  
  rubrica_address_get (address, &tipo, &via, &numero, &citta,
		       &cap, &provincia, NULL, &nazione);
  
  g_print("\n ************ Secondo estratto");
  g_print("\n\nTipo: %s", tipo);
  g_print("\nvia: %s", via);
  g_print("\nnumero: %s", numero);
  g_print("\ncitta': %s", citta);
  g_print("\ncap: %s", cap);
  g_print("\nprovincia: %s", provincia);
  g_print("\nstato: %s", stato);
  g_print("\nnazione: %s", nazione);
  
  g_print("\n ************* libero la memoria\n");
  rubrica_address_free(address);

  return 0;
}
