#include <glib.h>
#include <glib-object.h>

#include <libral.h>



int 
main(int argc, char* argv[])
{
  RubricaGroups* groups;
  RubricaGroups* copy;
  gboolean bool;
  gchar *data;  

  g_type_init();

  groups = rubrica_groups_new();

  g_print("\n\nmake groups...");
  g_print("\nadd:\tfirst\tsecond\tthird\tfourth");
  rubrica_groups_add_group(groups, "first");
  rubrica_groups_add_group(groups, "second");
  rubrica_groups_add_group(groups, "third");
  rubrica_groups_add_group(groups, "fourth");
  
  g_print("\n\nprint groups");
  data = rubrica_groups_get_group(groups);
  for (; data; data = rubrica_groups_get_next_group(groups))
    g_print("\ngroup: %s", data);
  
  g_print("\n\ntest if group own \"second\" and \"my-group\"");
  bool = rubrica_groups_owns_group(groups, "second");
  g_print("\ngroups %s %s", bool ? "owns" : "not owns", "second");

  bool = rubrica_groups_owns_group(groups, "my-group");
  g_print("\ngroups %s %s", bool ? "owns" : "not owns", "my-group");
  
  g_print("\n\nNow delete the group \"third\"");  
  rubrica_groups_delete_group(groups, "third");

  g_print("\nModify the group \"fourth\" to \"new-group\"");
  rubrica_groups_modify_group(groups, "fourth", "new-group");
  
  g_print("\n\nprint groups");
  rubrica_groups_reset(groups);
  data = rubrica_groups_get_group(groups);
  for (; data; data = rubrica_groups_get_next_group(groups))
    g_print("\ngroup: %s", data);  
  
  g_print("\n\ncopy the groups");
  copy = rubrica_groups_copy(groups);
  
  g_print("\nfree groups");
  rubrica_groups_free(groups);

  g_print("\n\nprint copied groups");
  rubrica_groups_reset(copy);
  data = rubrica_groups_get_group(copy);
  for (; data; data = rubrica_groups_get_next_group(copy))
    g_print("\ngroup: %s", data);  

  g_print("\nfree copy");
  rubrica_groups_free(copy);

  g_print("\n\nIt works... ;-)\n\n");

  return 0;
}


