#include <glib.h>
#include <stdio.h>

#include <libral.h>


void print_card(RubricaAbook* book, gpointer card, gpointer user_data)
{
  gchar key;
  RubricaCardClass* klass;
  
  klass =  RUBRICA_CARD_GET_CLASS(card);
  if (RUBRICA_CARD_CLASS(klass)->print_card)
    RUBRICA_CARD_CLASS(klass)->print_card(card);

  g_print("\n\npress a key");
  scanf("%c", &key);
}


int main (int argc, char* argv[])
{
  RubricaAbook* book, *book_copy;
  gpointer data;
  RubricaCardClass* klass;

  RubricaPersonalCard *card, *card2, *copia;
  RubricaCompanyCard *cmp, *copia_cmp;
  RubricaGroups* groups;
  RubricaContact* contact;
  RubricaWork* work;
  RubricaNotes* notes;
  RubricaTelephone* tel;
  RubricaNetAddress* net;
  RubricaAddress* add;
  RubricaRef* ref;

  gchar *tmp;

  
  g_type_init();
  
  g_print("\nMaking new addressbook");
  book = rubrica_abook_new();  

  g_print("\ngetting filename and path... filename: %s\tpath: %s", 
	  rubrica_abook_get_name(book),
	  rubrica_abook_get_path(book));

  rubrica_abook_set_name(book, "libral-addressbook-test.rub");
  rubrica_abook_set_path(book, "/home/nicola/.rubrica");  
 
  g_print("\nI've setted new values filename: %s\tpath: %s", 
	  rubrica_abook_get_name(book),
	  rubrica_abook_get_path(book));
  
  /* First personal card */
  g_print("\nMaking first Personal Card...  (with a test align)");
  g_print("\nfirst card id, pc1, aligned to id pc10");
  card    = rubrica_personal_card_new();
  contact = rubrica_contact_new();
  work    = rubrica_work_new();
  notes   = rubrica_notes_new();

  rubrica_card_set(RUBRICA_CARD(card), TRUE, FALSE, FALSE, 
		   "Autore Rubrica", 5);

  rubrica_card_set_id(RUBRICA_CARD(card), "pc10");
  /* ignore, test of private member */
  klass =  RUBRICA_CARD_GET_CLASS(card);
  if (RUBRICA_CARD_CLASS(klass)->align_id)
    RUBRICA_CARD_CLASS(klass)->align_id(card, "pc10", "personal");
  /* test of private member*/ 


  groups = rubrica_groups_new();  
  rubrica_groups_add_group(groups, "favorites");
  rubrica_groups_add_group(groups, "user_made_group");
  rubrica_groups_add_group(groups, "strategies");
  rubrica_card_set_groups(RUBRICA_CARD(card), groups);

  rubrica_contact_set(contact, "Nicola", "Giuseppe", "Fragale",
		      "the bEsT", "Software Engegneer (I hope)", NULL, 
		      NULL, "photo", 12345678);
  
  rubrica_work_set(work, "Student", "org", "dep", "subdep", 
		   "manager", "manager's telephone",
		   "collaborator", "collaborator's telephone");

  rubrica_notes_set(notes, FALSE, TRUE, FALSE, "bla bla bla",  "gfjsfsjgf", 
		    "ppppppppp", "jjjfsfllfo4883jskdf8878s***é*é",
		    12211261, 12345687);

  rubrica_personal_card_set_contact(card, contact);
  rubrica_personal_card_set_work(card, work);
  rubrica_personal_card_set_notes(card, notes);

  add = rubrica_address_new(); 
  rubrica_address_set(add, RUBRICA_ADDRESS_HOME, "street", 
		      "number", "Lamezia Terme", "88046","CZ",
		      "Italy", "UE");
  rubrica_card_add_address(RUBRICA_CARD(card), add);

  add = rubrica_address_new(); 
  rubrica_address_set(add, RUBRICA_ADDRESS_WORK, "Work address",
		      "484746", "MI", "84349", "MI", "IT", "UE");
  rubrica_card_add_address(RUBRICA_CARD(card), add);

  tel = rubrica_telephone_new();
  rubrica_telephone_set(tel, "0968 123456", "home");
  rubrica_card_add_telephone(RUBRICA_CARD(card), tel);

  tel = rubrica_telephone_new();
  rubrica_telephone_set(tel, "0968 9876543", "home");
  rubrica_card_add_telephone(RUBRICA_CARD(card), tel);

  net = rubrica_net_address_new();
  rubrica_net_address_set(net, "nicolafragale@libero.it", 
			  RUBRICA_NET_ADDRESS_EMAIL);
  rubrica_card_add_net_address(RUBRICA_CARD(card), net);
  
  net = rubrica_net_address_new();
  rubrica_net_address_set(net, "http://digilander.libero.it/nfragale", 
			  RUBRICA_NET_ADDRESS_WEB);
  rubrica_card_add_net_address(RUBRICA_CARD(card), net);  


  /* Second personal card */
  g_print("\nMaking second Personal Card (I expect pc2 ==> pc11)");
  g_print("\ntest align to pc5 (must fail)");
  card2   = rubrica_personal_card_new();

  /* ignore, test of private member */
  klass =  RUBRICA_CARD_GET_CLASS(card2);
  if (RUBRICA_CARD_CLASS(klass)->align_id)
    RUBRICA_CARD_CLASS(klass)->align_id(card, "pc5", "personal");
  g_print("\ncard's id: %s", rubrica_card_get_id(RUBRICA_CARD(card2)));
  /* test of private member*/ 

  rubrica_card_set(RUBRICA_CARD(card2), TRUE, FALSE, 
		   FALSE, "Rubrica Author", 5);

  groups = rubrica_groups_new();
  rubrica_groups_add_group(groups, "programmers");
  rubrica_card_set_groups(RUBRICA_CARD(card2), groups);

  contact = rubrica_contact_new();
  rubrica_contact_set(contact, "Nicola", "", "Fragale", "nick",
		      "Software Engegneer (I hope) ;-)", "Mr", "title",
		      "photo2", 12121212);
  rubrica_personal_card_set_contact(card2, contact);

  work    = rubrica_work_new();
  rubrica_work_set(work, "the work", "org", "dep", "subdep",
		   "manager", "+39 0 987-654 321", "Miss Foo", "123 456 789");
  rubrica_personal_card_set_work(card2, work);
  
  notes   = rubrica_notes_new();
  rubrica_notes_set(notes, FALSE, FALSE, FALSE, "", "", "", 
		    "sdkfskdfhjksdhfsjdkfhkjds", -1, -1);  
  rubrica_personal_card_set_notes(card2, notes);

  add = rubrica_address_new();
  rubrica_address_set(add, RUBRICA_ADDRESS_DOM, "the street"
		      , "the street number", "Lamezia Terme", "88046", 
		      "CZ", "Italy", "UE");
  rubrica_card_add_address(RUBRICA_CARD(card2), add);
  
  tel = rubrica_telephone_new();
  rubrica_telephone_set(tel, "098 7654321", "cellphone");
  rubrica_card_add_telephone(RUBRICA_CARD(card2), tel);
  
  net = rubrica_net_address_new();
  rubrica_net_address_set(net, "454545", RUBRICA_NET_ADDRESS_IRC_JABBER);
  rubrica_card_add_net_address(RUBRICA_CARD(card2), net);  

  net = rubrica_net_address_new();
  rubrica_net_address_set(net, "098761", RUBRICA_NET_ADDRESS_IRC_ICQ);
  rubrica_card_add_net_address(RUBRICA_CARD(card2), net); 


  /* Company card */
  g_print("\nMaking first Company Card");
  cmp = rubrica_company_card_new();
  rubrica_card_set(RUBRICA_CARD(cmp), 
		   TRUE,           /* deletable card */
		   FALSE,          /* deleted card   */
		   FALSE,          /* marked card    */
		   "Foo INC",      /* card name      */
		   5);             /* card rank      */

  groups = rubrica_groups_new();
  rubrica_groups_add_group(groups, "bussines");
  rubrica_card_set_groups(RUBRICA_CARD(cmp), groups);

  rubrica_company_card_set(cmp, 
			   "Foo INC",          /* company name */
			   "nclfrg18m3t208x",  /* partita iva/codice fiscale*/
			   "Notes, bla bla bla, foo foo foo ...");  /* notes */

  ref = rubrica_ref_with_id_new(rubrica_card_get_id(RUBRICA_CARD(card)));
  rubrica_ref_set_info(ref, "best client I had....");
  rubrica_company_card_add_ref(RUBRICA_COMPANY_CARD(cmp), ref);

  add = rubrica_address_new(); 
  rubrica_address_set(add, RUBRICA_ADDRESS_COMPANY, "company street", 
		      "street number", "Lamezia Terme", "88046","CZ",
		      "Italy", "UE");
  rubrica_card_add_address(RUBRICA_CARD(cmp), add); 

  tel = rubrica_telephone_new();
  rubrica_telephone_set(tel, "0968 111222", "work");
  rubrica_card_add_telephone(RUBRICA_CARD(cmp), tel);

  tel = rubrica_telephone_new();
  rubrica_telephone_set(tel, "0968 111333", "fax");
  rubrica_card_add_telephone(RUBRICA_CARD(cmp), tel);
  
  net = rubrica_net_address_new();
  rubrica_net_address_set(net, "nicolafragale@foo.com", 
			  RUBRICA_NET_ADDRESS_EMAIL);
  rubrica_card_add_net_address(RUBRICA_CARD(cmp), net);

  net = rubrica_net_address_new();
  rubrica_net_address_set(net, "http://www.theCompanyInc.com", 
			  RUBRICA_NET_ADDRESS_WEB);
  rubrica_card_add_net_address(RUBRICA_CARD(cmp), net);  
  

  /* Do stuff */
  g_print("\n\nCopying cards...");
  g_print("\nI will copy the first personal card");
  copia = rubrica_card_copy(RUBRICA_CARD(card));
  tmp = g_strdup_printf("%s (Copia)", 
			rubrica_card_get_card_name(RUBRICA_CARD(card)));
  rubrica_card_set_card_name(RUBRICA_CARD(copia), tmp);
  g_free(tmp);

  g_print("\nI will copy the company card (align test on copy)");
  g_print("\ncc2 (cc1 copy will be cc123)");
  tmp = g_strdup_printf("%s (Copia)", 
			rubrica_card_get_card_name(RUBRICA_CARD(cmp)));  
  copia_cmp = rubrica_card_copy(RUBRICA_CARD(cmp));
  rubrica_card_set_card_name(RUBRICA_CARD(copia_cmp), tmp);
  g_free(tmp);

  rubrica_card_set_id(RUBRICA_CARD(copia_cmp), "cc123");
  klass =  RUBRICA_CARD_GET_CLASS(copia_cmp);
  if (RUBRICA_CARD_CLASS(klass)->align_id)
    RUBRICA_CARD_CLASS(klass)->align_id(copia_cmp, "cc123", "company");

  g_print("\ncopy id: %s (before cc align)", 
	  rubrica_card_get_id(RUBRICA_CARD(copia_cmp)));


  /* Build Addressbook */
  g_print("\n\nAdding cards to addressbook...");
  rubrica_abook_add_card(book, card);
  rubrica_abook_add_card(book, card2);
  rubrica_abook_add_card(book, cmp);
  rubrica_abook_add_card(book, copia);
  rubrica_abook_add_card(book, copia_cmp);

  g_print("\n\nDo somethings with addressbook"
	  "\nThis addressbook has %d item(s)",
	  rubrica_abook_get_items(book));

  g_print("\n\nCopy address book");
  book_copy = rubrica_abook_copy(book);
  g_print("\nprint book copy");
  data = rubrica_abook_get_card(book_copy);
  for (; data; data = rubrica_abook_get_next_card(book_copy))
    rubrica_card_print(RUBRICA_CARD(data));

  data = NULL;
  g_print("\n\nGetting a card from addressbook (get_by_id)");
  g_print("\nget card with \"pc2\" id");
  g_print("\nthis card dosn't exist (id has been aligned)");
  data = rubrica_abook_get_card_by_id(book, "pc2"); 
  if (!data)
    g_print("\nCan't find requested card. ALIGN WORKED!");


  g_print("\nOk... now get the *real* second personal card (id is pc11)");
  data = rubrica_abook_get_card_by_id(book, "pc11");  
  g_print("\ngot, now print card's data");
  rubrica_card_print(RUBRICA_CARD(data));

  g_print("\n\nOk... try to save addressbook");
  if (g_file_test(rubrica_abook_get_name(book), G_FILE_TEST_EXISTS))
    remove(rubrica_abook_get_name(book));
  if(rubrica_abook_save_file(book, rubrica_abook_get_name(book)))
    g_print("\n%s saved", rubrica_abook_get_name(book));
  else
    g_print("\nWARNING, addressbook not saved");
  
  g_print("\n\nRemove a card from addressbook");
  g_print("\nItems before: %d", rubrica_abook_get_items(book));
  g_print("\nNow I'm removing the card with id \"pc11\"");
  rubrica_abook_remove_card(book, data);
  g_print("\nItems after: %d", rubrica_abook_get_items(book));  
    
  g_print("\n\nFree memory");
  rubrica_card_free(RUBRICA_CARD(card));
  rubrica_card_free(RUBRICA_CARD(cmp));
  rubrica_card_free(RUBRICA_CARD(copia));
  rubrica_card_free(RUBRICA_CARD(copia_cmp));

  g_print("\nfree addressbook (cards have been freed"
	  " before, just free book's data)");
  rubrica_abook_free(book);

  g_print("\nand its copy (free all addressbook, "
	  "addressbook's data and stored cards");
  rubrica_abook_free(book_copy);  
  
  g_print("\n\nTry to load the saved addressbook...");
  book = rubrica_abook_new(); 
  rubrica_abook_set_name(book, "libral-addressbook-test.rub");
  rubrica_abook_set_path(book, "/home/nicola/.rubrica"); 

  g_signal_connect(G_OBJECT(book), "card_read", 
		   G_CALLBACK(print_card), NULL);
  

  if (rubrica_abook_open_file(book, "libral-addressbook-test.rub"))
    g_print("\nAddressbook loaded");
 
  /*
    g_print("\nprint book loaded");
    data = rubrica_abook_get_card(book);
    for (; data; data = rubrica_abook_get_next_card(book))
      rubrica_card_print(RUBRICA_CARD(data)); 
  */
  
  g_print("\n\n");
  return 0;
}
