#include <glib.h>
#include <glib-object.h>

#include <libral.h>


int 
main(int argc, char* argv[])
{
  RubricaAbookVCard* book;
  gpointer data;
  
  g_type_init();
  
  book = rubrica_abook_vcard_new();
  rubrica_abook_set_name(RUBRICA_ABOOK(book), "./rubrica.vcd");
  rubrica_abook_set_path(RUBRICA_ABOOK(book), ".");

  if (rubrica_abook_open_file(RUBRICA_ABOOK(book), "./rubrica.vcd"))
    {
      g_print("\nAddressbook: %s (path: %s) successfully opened",
	      rubrica_abook_get_name(RUBRICA_ABOOK(book)),
	      rubrica_abook_get_path(RUBRICA_ABOOK(book)));
      g_print("\nItems in addressbook: %d",
	      rubrica_abook_get_items(RUBRICA_ABOOK(book)));
      
      g_print("\n\nprint addressbook");
      data = rubrica_abook_get_card(RUBRICA_ABOOK(book));
      for (; data; data = rubrica_abook_get_next_card(RUBRICA_ABOOK(book)))
	{
	  g_print("\nPrinting: %s", 
		  rubrica_card_get_card_name(RUBRICA_CARD(data)));
	  rubrica_card_print(RUBRICA_CARD(data));
	}
    }
  
  if(!rubrica_abook_save_file(RUBRICA_ABOOK(book), "imported_from_vcard.rub"))
    g_print("\nCan't save file");
  
  g_print("\n\nIt works... ;-)\n\n");

  return 0;
}


